<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_06) on Wed Aug 20 17:16:43 PDT 2008 -->
<TITLE>
Preconditions (Google Collections Library - snapshot-20080820 (ALPHA))
</TITLE>

<META NAME="keywords" CONTENT="com.google.common.base.Preconditions class">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="Preconditions (Google Collections Library - snapshot-20080820 (ALPHA))";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/base/Objects.html" title="class in com.google.common.base"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../com/google/common/base/Predicate.html" title="interface in com.google.common.base"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/base/Preconditions.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Preconditions.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
com.google.common.base</FONT>
<BR>
Class Preconditions</H2>
<PRE>
<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>com.google.common.base.Preconditions</B>
</PRE>
<HR>
<DL>
<DT><PRE>public final class <B>Preconditions</B><DT>extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></DL>
</PRE>

<P>
Simple static methods to be called at the start of your own methods to verify
 correct arguments and state. This allows constructs such as
 <pre>
     if (count <= 0) {
       throw new IllegalArgumentException("must be positive: " + count);
     }</pre>

 to be replaced with the more compact
 <pre>
     checkArgument(count > 0, "must be positive: %s", count);</pre>

 Note that the sense of the expression is inverted; with <code>Preconditions</code>
 you declare what you expect to be <i>true</i>, just as you do with an
 <a href="http://java.sun.com/j2se/1.5.0/docs/guide/language/assert.html">
 <code>assert</code></a> or a JUnit <code>assertTrue()</code> call.

 <p>Take care not to confuse precondition checking with other similar types
 of checks! Precondition exceptions -- including those provided here, but also
 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IndexOutOfBoundsException.html" title="class or interface in java.lang"><CODE>IndexOutOfBoundsException</CODE></A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/NoSuchElementException.html" title="class or interface in java.util"><CODE>NoSuchElementException</CODE></A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/UnsupportedOperationException.html" title="class or interface in java.lang"><CODE>UnsupportedOperationException</CODE></A> and others -- are used to signal that the
 <i>calling method</i> has made an error. This tells the caller that it should
 not have invoked the method when it did, with the arguments it did, or
 perhaps <i>ever</i>. Postcondition or other invariant failures should not
 throw these types of exceptions.

 <p><b>Note:</b> The methods of the <code>Preconditions</code> class are highly
 unusual in one way: they are <i>supposed to</i> throw exceptions, and promise
 in their specifications to do so even when given perfectly valid input. That
 is, <code>null</code> is a valid parameter to the method <A HREF="../../../../com/google/common/base/Preconditions.html#checkNotNull(T)"><CODE>checkNotNull(Object)</CODE></A> -- and technically this parameter could be even marked
 as <A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base"><CODE>Nullable</CODE></A> -- yet the method will still throw an exception anyway,
 because that's what its contract says to do.
<P>

<P>
<DL>
<DT><B>Author:</B></DT>
  <DD>Kevin Bourrillion</DD>
</DL>
<HR>

<P>

<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkArgument(boolean)">checkArgument</A></B>(boolean&nbsp;expression)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures the truth of an expression involving one or more parameters to the
 calling method.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkArgument(boolean, java.lang.Object)">checkArgument</A></B>(boolean&nbsp;expression,
              <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;errorMessage)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures the truth of an expression involving one or more parameters to the
 calling method.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkArgument(boolean, java.lang.String, java.lang.Object...)">checkArgument</A></B>(boolean&nbsp;expression,
              <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A>&nbsp;errorMessageTemplate,
              <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>...&nbsp;errorMessageArgs)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures the truth of an expression involving one or more parameters to the
 calling method.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;?&gt;&gt;
<BR>
T</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkContentsNotNull(T)">checkContentsNotNull</A></B>(T&nbsp;iterable)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures that an <code>Iterable</code> object passed as a parameter to the
 calling method is not null and contains no null elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;?&gt;&gt;
<BR>
T</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkContentsNotNull(T, java.lang.Object)">checkContentsNotNull</A></B>(T&nbsp;iterable,
                     <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;errorMessage)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures that an <code>Iterable</code> object passed as a parameter to the
 calling method is not null and contains no null elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;?&gt;&gt;
<BR>
T</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkContentsNotNull(T, java.lang.String, java.lang.Object...)">checkContentsNotNull</A></B>(T&nbsp;iterable,
                     <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A>&nbsp;errorMessageTemplate,
                     <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>...&nbsp;errorMessageArgs)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures that an <code>Iterable</code> object passed as a parameter to the
 calling method is not null and contains no null elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; T</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkNotNull(T)">checkNotNull</A></B>(T&nbsp;reference)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures that an object reference passed as a parameter to the calling
 method is not null.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; T</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkNotNull(T, java.lang.Object)">checkNotNull</A></B>(T&nbsp;reference,
             <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;errorMessage)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures that an object reference passed as a parameter to the calling
 method is not null.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;T&gt; T</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkNotNull(T, java.lang.String, java.lang.Object...)">checkNotNull</A></B>(T&nbsp;reference,
             <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A>&nbsp;errorMessageTemplate,
             <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>...&nbsp;errorMessageArgs)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures that an object reference passed as a parameter to the calling
 method is not null.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkState(boolean)">checkState</A></B>(boolean&nbsp;expression)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures the truth of an expression involving the state of the calling
 instance, but not involving any parameters to the calling method.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkState(boolean, java.lang.Object)">checkState</A></B>(boolean&nbsp;expression,
           <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;errorMessage)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures the truth of an expression involving the state of the calling
 instance, but not involving any parameters to the calling method.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/base/Preconditions.html#checkState(boolean, java.lang.String, java.lang.Object...)">checkState</A></B>(boolean&nbsp;expression,
           <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A>&nbsp;errorMessageTemplate,
           <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>...&nbsp;errorMessageArgs)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ensures the truth of an expression involving the state of the calling
 instance, but not involving any parameters to the calling method.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#clone()" title="class or interface in java.lang">clone</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang">equals</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#hashCode()" title="class or interface in java.lang">hashCode</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#toString()" title="class or interface in java.lang">toString</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="checkArgument(boolean)"><!-- --></A><H3>
checkArgument</H3>
<PRE>
public static void <B>checkArgument</B>(boolean&nbsp;expression)</PRE>
<DL>
<DD>Ensures the truth of an expression involving one or more parameters to the
 calling method.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>expression</CODE> - a boolean expression
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if <code>expression</code> is false</DL>
</DD>
</DL>
<HR>

<A NAME="checkArgument(boolean, java.lang.Object)"><!-- --></A><H3>
checkArgument</H3>
<PRE>
public static void <B>checkArgument</B>(boolean&nbsp;expression,
                                 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;errorMessage)</PRE>
<DL>
<DD>Ensures the truth of an expression involving one or more parameters to the
 calling method.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>expression</CODE> - a boolean expression<DD><CODE>errorMessage</CODE> - the exception message to use if the check fails; will
     be converted to a string using <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html#valueOf(java.lang.Object)" title="class or interface in java.lang"><CODE>String.valueOf(Object)</CODE></A>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if <code>expression</code> is false</DL>
</DD>
</DL>
<HR>

<A NAME="checkArgument(boolean, java.lang.String, java.lang.Object...)"><!-- --></A><H3>
checkArgument</H3>
<PRE>
public static void <B>checkArgument</B>(boolean&nbsp;expression,
                                 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A>&nbsp;errorMessageTemplate,
                                 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>...&nbsp;errorMessageArgs)</PRE>
<DL>
<DD>Ensures the truth of an expression involving one or more parameters to the
 calling method.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>expression</CODE> - a boolean expression<DD><CODE>errorMessageTemplate</CODE> - a template for the exception message should the
     check fail. The message is formed by replacing each <code>%s</code>
     placeholder in the template with an argument. These are matched by
     position - the first <code>%s</code> gets <code>errorMessageArgs[0]</code>, etc.
     Unmatched arguments will be appended to the formatted message in square
     braces. Unmatched placeholders will be left as-is.<DD><CODE>errorMessageArgs</CODE> - the arguments to be substituted into the message
     template. Arguments are converted to strings using
     <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html#valueOf(java.lang.Object)" title="class or interface in java.lang"><CODE>String.valueOf(Object)</CODE></A>.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if <code>expression</code> is false
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/NullPointerException.html" title="class or interface in java.lang">NullPointerException</A></CODE> - if the check fails and either <code>errorMessageTemplate</code> or <code>errorMessageArgs</code> is null (don't let
     this happen)</DL>
</DD>
</DL>
<HR>

<A NAME="checkState(boolean)"><!-- --></A><H3>
checkState</H3>
<PRE>
public static void <B>checkState</B>(boolean&nbsp;expression)</PRE>
<DL>
<DD>Ensures the truth of an expression involving the state of the calling
 instance, but not involving any parameters to the calling method.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>expression</CODE> - a boolean expression
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IllegalStateException.html" title="class or interface in java.lang">IllegalStateException</A></CODE> - if <code>expression</code> is false</DL>
</DD>
</DL>
<HR>

<A NAME="checkState(boolean, java.lang.Object)"><!-- --></A><H3>
checkState</H3>
<PRE>
public static void <B>checkState</B>(boolean&nbsp;expression,
                              <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;errorMessage)</PRE>
<DL>
<DD>Ensures the truth of an expression involving the state of the calling
 instance, but not involving any parameters to the calling method.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>expression</CODE> - a boolean expression<DD><CODE>errorMessage</CODE> - the exception message to use if the check fails; will
     be converted to a string using <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html#valueOf(java.lang.Object)" title="class or interface in java.lang"><CODE>String.valueOf(Object)</CODE></A>
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IllegalStateException.html" title="class or interface in java.lang">IllegalStateException</A></CODE> - if <code>expression</code> is false</DL>
</DD>
</DL>
<HR>

<A NAME="checkState(boolean, java.lang.String, java.lang.Object...)"><!-- --></A><H3>
checkState</H3>
<PRE>
public static void <B>checkState</B>(boolean&nbsp;expression,
                              <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A>&nbsp;errorMessageTemplate,
                              <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>...&nbsp;errorMessageArgs)</PRE>
<DL>
<DD>Ensures the truth of an expression involving the state of the calling
 instance, but not involving any parameters to the calling method.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>expression</CODE> - a boolean expression<DD><CODE>errorMessageTemplate</CODE> - a template for the exception message should the
     check fail. The message is formed by replacing each <code>%s</code>
     placeholder in the template with an argument. These are matched by
     position - the first <code>%s</code> gets <code>errorMessageArgs[0]</code>, etc.
     Unmatched arguments will be appended to the formatted message in square
     braces. Unmatched placeholders will be left as-is.<DD><CODE>errorMessageArgs</CODE> - the arguments to be substituted into the message
     template. Arguments are converted to strings using
     <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html#valueOf(java.lang.Object)" title="class or interface in java.lang"><CODE>String.valueOf(Object)</CODE></A>.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IllegalStateException.html" title="class or interface in java.lang">IllegalStateException</A></CODE> - if <code>expression</code> is false
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/NullPointerException.html" title="class or interface in java.lang">NullPointerException</A></CODE> - if the check fails and either <code>errorMessageTemplate</code> or <code>errorMessageArgs</code> is null (don't let
     this happen)</DL>
</DD>
</DL>
<HR>

<A NAME="checkNotNull(java.lang.Object)"><!-- --></A><A NAME="checkNotNull(T)"><!-- --></A><H3>
checkNotNull</H3>
<PRE>
public static &lt;T&gt; T <B>checkNotNull</B>(T&nbsp;reference)</PRE>
<DL>
<DD>Ensures that an object reference passed as a parameter to the calling
 method is not null.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>reference</CODE> - an object reference
<DT><B>Returns:</B><DD>the non-null reference that was validated
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/NullPointerException.html" title="class or interface in java.lang">NullPointerException</A></CODE> - if <code>reference</code> is null</DL>
</DD>
</DL>
<HR>

<A NAME="checkNotNull(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="checkNotNull(T, java.lang.Object)"><!-- --></A><H3>
checkNotNull</H3>
<PRE>
public static &lt;T&gt; T <B>checkNotNull</B>(T&nbsp;reference,
                                 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;errorMessage)</PRE>
<DL>
<DD>Ensures that an object reference passed as a parameter to the calling
 method is not null.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>reference</CODE> - an object reference<DD><CODE>errorMessage</CODE> - the exception message to use if the check fails; will
     be converted to a string using <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html#valueOf(java.lang.Object)" title="class or interface in java.lang"><CODE>String.valueOf(Object)</CODE></A>
<DT><B>Returns:</B><DD>the non-null reference that was validated
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/NullPointerException.html" title="class or interface in java.lang">NullPointerException</A></CODE> - if <code>reference</code> is null</DL>
</DD>
</DL>
<HR>

<A NAME="checkNotNull(java.lang.Object,java.lang.String,java.lang.Object)"><!-- --></A><A NAME="checkNotNull(T, java.lang.String, java.lang.Object...)"><!-- --></A><H3>
checkNotNull</H3>
<PRE>
public static &lt;T&gt; T <B>checkNotNull</B>(T&nbsp;reference,
                                 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A>&nbsp;errorMessageTemplate,
                                 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>...&nbsp;errorMessageArgs)</PRE>
<DL>
<DD>Ensures that an object reference passed as a parameter to the calling
 method is not null.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>reference</CODE> - an object reference<DD><CODE>errorMessageTemplate</CODE> - a template for the exception message should the
     check fail. The message is formed by replacing each <code>%s</code>
     placeholder in the template with an argument. These are matched by
     position - the first <code>%s</code> gets <code>errorMessageArgs[0]</code>, etc.
     Unmatched arguments will be appended to the formatted message in square
     braces. Unmatched placeholders will be left as-is.<DD><CODE>errorMessageArgs</CODE> - the arguments to be substituted into the message
     template. Arguments are converted to strings using
     <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html#valueOf(java.lang.Object)" title="class or interface in java.lang"><CODE>String.valueOf(Object)</CODE></A>.
<DT><B>Returns:</B><DD>the non-null reference that was validated
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/NullPointerException.html" title="class or interface in java.lang">NullPointerException</A></CODE> - if <code>reference</code> is null</DL>
</DD>
</DL>
<HR>

<A NAME="checkContentsNotNull(java.lang.Iterable)"><!-- --></A><A NAME="checkContentsNotNull(T)"><!-- --></A><H3>
checkContentsNotNull</H3>
<PRE>
public static &lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;?&gt;&gt; T <B>checkContentsNotNull</B>(T&nbsp;iterable)</PRE>
<DL>
<DD>Ensures that an <code>Iterable</code> object passed as a parameter to the
 calling method is not null and contains no null elements.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>iterable</CODE> - the iterable to check the contents of
<DT><B>Returns:</B><DD>the non-null <code>iterable</code> reference just validated
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/NullPointerException.html" title="class or interface in java.lang">NullPointerException</A></CODE> - if <code>iterable</code> is null or contains at
     least one null element</DL>
</DD>
</DL>
<HR>

<A NAME="checkContentsNotNull(java.lang.Iterable,java.lang.Object)"><!-- --></A><A NAME="checkContentsNotNull(T, java.lang.Object)"><!-- --></A><H3>
checkContentsNotNull</H3>
<PRE>
public static &lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;?&gt;&gt; T <B>checkContentsNotNull</B>(T&nbsp;iterable,
                                                             <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;errorMessage)</PRE>
<DL>
<DD>Ensures that an <code>Iterable</code> object passed as a parameter to the
 calling method is not null and contains no null elements.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>iterable</CODE> - the iterable to check the contents of<DD><CODE>errorMessage</CODE> - the exception message to use if the check fails; will
     be converted to a string using <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html#valueOf(java.lang.Object)" title="class or interface in java.lang"><CODE>String.valueOf(Object)</CODE></A>
<DT><B>Returns:</B><DD>the non-null <code>iterable</code> reference just validated
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/NullPointerException.html" title="class or interface in java.lang">NullPointerException</A></CODE> - if <code>iterable</code> is null or contains at
     least one null element</DL>
</DD>
</DL>
<HR>

<A NAME="checkContentsNotNull(java.lang.Iterable,java.lang.String,java.lang.Object)"><!-- --></A><A NAME="checkContentsNotNull(T, java.lang.String, java.lang.Object...)"><!-- --></A><H3>
checkContentsNotNull</H3>
<PRE>
public static &lt;T extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;?&gt;&gt; T <B>checkContentsNotNull</B>(T&nbsp;iterable,
                                                             <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html" title="class or interface in java.lang">String</A>&nbsp;errorMessageTemplate,
                                                             <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>...&nbsp;errorMessageArgs)</PRE>
<DL>
<DD>Ensures that an <code>Iterable</code> object passed as a parameter to the
 calling method is not null and contains no null elements.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>iterable</CODE> - the iterable to check the contents of<DD><CODE>errorMessageTemplate</CODE> - a template for the exception message should the
     check fail. The message is formed by replacing each <code>%s</code>
     placeholder in the template with an argument. These are matched by
     position - the first <code>%s</code> gets <code>errorMessageArgs[0]</code>, etc.
     Unmatched arguments will be appended to the formatted message in square
     braces. Unmatched placeholders will be left as-is.<DD><CODE>errorMessageArgs</CODE> - the arguments to be substituted into the message
     template. Arguments are converted to strings using
     <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/String.html#valueOf(java.lang.Object)" title="class or interface in java.lang"><CODE>String.valueOf(Object)</CODE></A>.
<DT><B>Returns:</B><DD>the non-null <code>iterable</code> reference just validated
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/NullPointerException.html" title="class or interface in java.lang">NullPointerException</A></CODE> - if <code>iterable</code> is null or contains at
     least one null element</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/base/Objects.html" title="class in com.google.common.base"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../com/google/common/base/Predicate.html" title="interface in com.google.common.base"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/base/Preconditions.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Preconditions.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
